/*
 * AHRS.c
 *
 *  Created on: 29.10.2010
 *      Author: Filip
 */
#include "AHRS.h"
#include "compiler.h"
#include "math.h"

float atan_deg(float f){
 return (atanf(f)*180)/M_PI;
}

int Get_Acceleration(int ax, int ay, int az){
return sqrt((ax*ax)+(ay*ay)+(az*az));
}

void update_position(position_t *p, int ax, int ay, int az, int gx, int gy,int gz, float read_time){
float temp2;
int enable=1;

p->acceleration = Get_Acceleration(ax,ay,az);

//if(((temp < p->acceleration + 4)&(temp > p->acceleration - 4))|(p->safe_counter>30)){ p->acceleration = temp;//(p->acceleration+temp)/2;

/*
if((p->acceleration>=260)&(p->acceleration<=272)){ //validn udaje z ACC
	p->safe_counter++;
}
else p->safe_counter=0;

if ((p->safe_counter == 3)&0 )
{
 p->safe_counter=0;
 temp2 = atan_deg((float)ay/(float)az);
 p->pitch_error = p->pitch_angle - temp2;
 p->pitch_angle = temp2;
 temp2 = atan_deg((float)ax/(float)az);
 p->roll_error = p->roll_angle - temp2;
 p->roll_angle = temp2;
 enable=0;
 p->update_counter++;
}
//}else{
//	p->safe_counter++;
//}
*/
if(enable){ //integrace GX A GZ
		if ((p->acceleration>=245)&(p->acceleration<=287)){
			complementary_filter(p, read_time, gx, gy, gz, ax, ay, az) ;
		}
		else{
		//osa X
			if ((gy < 378) || (gy > 379)){
				temp2= -(((float)gy - 378.72)/1.03); //pepoet na stupn za sekundu
				p->pitch_angle += temp2* read_time; //integrace rotace v zvislosti na ase
			}
  //osa Y
			if ((gx < 379) || (gx > 383))
			{
				temp2= -(((float)gx - 381)/1.03); //pepoet na stupn za sekundu
				p->roll_angle += temp2* read_time; //integrace rotace v zvislosti na ase
			}
		}
}
}

int update_compass(int mx,int my){
	int compass_angle= atan_deg((float)my/(float)mx);
	return compass_angle;
}
/*
int gyro_filter (position_t *p, int g_new,float time)
{
	p->gy_amplitude[2] = p->gy_amplitude[1];
	p->gy_amplitude[1] = p->gy_amplitude[0];
	p->gy_amplitude[0] = g_new;
	int dif_12 = abs(p->gy_amplitude[2]-p->gy_amplitude[1]);
	int dif_23 = abs(p->gy_amplitude[3]-p->gy_amplitude[2]);
	int dif_13 = abs(p->gy_amplitude[1]-p->gy_amplitude[3]);

	if (p->suspect_point == 1)
				{
					 if ((dif_12<dif_13)&(dif_23<dif_13))
					 {
						 p->suspect_point = 0;
					 }
					 else
					 {
						 p->gy_amplitude[1] = ((p->gy_amplitude[0]+p->gy_amplitude[2])/2);
					 }
				}
	else if (p->suspect_point == 0){
		if ((dif_12<dif_13)&(dif_23<dif_13))
		{
			p->suspect_point = 0;
		}
		else
		{
			p->suspect_point = 1;
		}
	 }
	 return  p->gy_amplitude[2];
}
*/
void complementary_filter(position_t *p,float time, float x_gyro, float y_gyro, float z_gyro, float x_acc, float y_acc, float z_acc)
{
	float temp = x_acc;
				x_acc = (((float)y_acc - Y_ACC_OFFSET)* Y_ACC_SCALE);
				y_acc = (((float)temp - X_ACC_OFFSET)* X_ACC_SCALE);
				z_acc = (((float)z_acc - Z_ACC_OFFSET)* Z_ACC_SCALE);
				x_gyro =(((float)x_gyro - X_G_OFFSET)* X_G_SCALE);		// pedn
				y_gyro =(((float)y_gyro - Y_G_OFFSET)* Y_G_SCALE);
				z_gyro =(((float)z_gyro - Z_G_OFFSET)* Z_G_SCALE);

	float coeficient = ((tau)/(tau+time));
	p->pitch_angle = (coeficient) * (p->pitch_angle + (x_gyro * time)) + ((1 - coeficient) * atan_deg(x_acc/z_acc));
	p->roll_angle = (coeficient) * (p->roll_angle + (y_gyro * time)) + ((1 - coeficient) * atan_deg(y_acc/z_acc));
}


