/*
 * AHRS.h
 *
 *  Created on: 29.10.2010
 *      Author: Filip
 */

#ifndef AHRS_H_
#define AHRS_H_

#  define X_ACC_OFFSET			-4.5
#  define Y_ACC_OFFSET			-5
#  define Z_ACC_OFFSET			7.5

#  define X_G_OFFSET			381.14
#  define Y_G_OFFSET			378.72
#  define Z_G_OFFSET			372

#  define X_ACC_SCALE			263.5
#  define Y_ACC_SCALE			265
#  define Z_ACC_SCALE			253.5

#  define X_G_SCALE				1.03
#  define Y_G_SCALE				1.03
#  define Z_G_SCALE				1		// zjistit hodnotu

#define tau		0.15	// 0.75

typedef struct
{
  float pitch_angle;
  float roll_angle;
  float pitch_error;
  float roll_error;
  float acceleration;
  int safe_counter;
  unsigned int update_counter;

  int gy_amplitude [3];
  float read_time [2];
  char suspect_point;

  float x_angle;
  float y_angle;

} position_t;

float atan_deg(float f);
int Get_Acceleration(int ax, int ay, int az);
void update_position(position_t *p, int ax, int ay, int az, int gx, int gy, int gz, float read_time);
int update_compass(int mx,int my);
int gyro_filter (position_t *p, int g_new, float time);
void complementary_filter(position_t *p, float time, float x_gyro, float y_gyro, float z_gyro, float x_acc, float y_acc, float z_acc);

#endif /* AHRS_H_ */
