/*
 * FIFO.cpp
 *
 *  Created on: 27.11.2010
 *      Author: Filip
 */

#include "FIFO.h"
#include "buzzer.h"

void buffer_char(char c);
char unbuffer_char(void);


int fifo_in(fifo_t *fifo, char c)
{
		if(fifo->tip==0){
			usart_write_char(MAIN_USART, c);
			MAIN_USART->ier = AVR32_USART_TXEMPTY_MASK;
			fifo->tip=1;
			return 1;
			}

        if ((fifo->end + 1) % FIFO_SIZE != fifo->start) {
                fifo->data[fifo->end] = c;
                fifo->end = (fifo->end + 1) % FIFO_SIZE;
                fifo->datacount++;
                return 1;
        }
        return 0;
}


char fifo_out(fifo_t *fifo)
{
        if (fifo->end != fifo->start){
                char temp = fifo->data[fifo->start];
                fifo->start = (fifo->start + 1) % FIFO_SIZE;
                fifo->datacount--;
                return(temp);
        }
        return 0;
}

/*
int fifo_out(fifo_t *fifo, unsigned char *c)
{
        if (fifo->end != fifo->start){
                *c = fifo->data[fifo->start];
                fifo->start = (fifo->start + 1) % FIFO_SIZE;
                fifo->datacount--;
                return(1);
        }
        return 0;
}
*/
void fifo_string(fifo_t *fifo, char *data){
	int i = 0;
	while(data[i] != 0){
		fifo_in(fifo, data[i]);
		i++;
	}
}

void fifo_number(fifo_t *fifo, int number)
{
if(number == 0)
{
	fifo_in(fifo, '0');
  return;
}
else if(number < 0)
{
	fifo_in(fifo, '-');
  number = -number;
}
int i;
for(i=10000;i >= 1; i = (i / 10))
{
  if(number >= i)
  {
	  fifo_in(fifo, '0' + ((number / i) % 10));
  }
}
}
