/*
 * FIFO.h
 *
 *  Created on: 27.11.2010
 *      Author: Filip
 */

#ifndef FIFO_H_
#define FIFO_H_

#include "avr32/io.h"
#include "usart.h"

#define FIFO_SIZE 100
#define MAIN_USART               	(&AVR32_USART1)

typedef struct
{
  char data[FIFO_SIZE];
  int start;
  int end;
  int datacount;
  int tip; //Transmit in progress


} fifo_t;

int fifo_in(fifo_t *fifo, char c);
char fifo_out(fifo_t *fifo);
//int fifo_out(fifo_t *fifo, unsigned char *c);
void fifo_string(fifo_t *fifo, char *data);
void fifo_number(fifo_t *fifo, int number);

#endif /* FIFO_H_ */
