/*
 * PID.c
 *
 *  Created on: 27.10.2010
 *      Author: Filip
 */
#include "compiler.h"
#include "PID.h"


void PID_setup (pid_t *select, float pgain, float igain, float dgain, float fusegain)
{
	select->start_fuse = fusegain/igain;
	select->pgain = pgain;
	select->igain = igain;
	select->dgain = dgain;
}
float PID (pid_t *select, float w, float y)
{

	float e = (w-y);

	//if((e > 0.8)||(e < -0.8)){
		select->d = select->dgain * (y-select->last_value);
	select->last_value = y;
	/*}else{
		e=0;
		select->d = 0;
		select->last_value = w;
	}*/


	select->p = select->pgain * e;
	select->istate += e;
	if (select->istate > select->start_fuse)
	{
		select->istate = select->start_fuse;
	}
	else if (select->istate < -select->start_fuse)
	{
		select->istate = -select->start_fuse;
	}
	select->i = select->igain*select->istate;
	return select->p + select->i + select->d;

}
