/*
 * error.c
 *
 *  Created on: 6.3.2011
 *      Author: Filip
 */
#include "compiler.h"
#include "error.h"

void error_report(error_t *handler,int code)
{
	handler->last_error = code;
	handler->transmit_error = code;
	if(handler->high_priority > code) handler->high_priority = code;
	handler->error_count++;
}
int error_transmit(error_t *handler){
	int temp;
	temp = handler->transmit_error;
	handler->transmit_error = 0;
	return temp;
}
int error_get_last(error_t *handler)
{
	int temp;
	temp = handler->last_error;
	handler->last_error = 0;
	return temp;
}
int error_get_hp(error_t *handler)
{
	int temp;
	temp = handler->high_priority;
	handler->high_priority = 0;
	return temp;
}
void error_clear_all(error_t *handler)
{
	handler->high_priority = 0;
	handler->last_error = 0;
	handler->transmit_error = 0;
}

int error_is_error(error_t *handler)
{
	if(handler->last_error !=0) return TRUE;
	else return FALSE;
}
int error_counter(error_t *handler)
{
	return handler->error_count;
}
