/*
 * main.c
 *
 *  Created on: 21.10.2010
 *      Author: Filip
 */

#  define PBACLK_FREQ_HZ 			33000000
#  define FOSC0						12000000
#  define OSC0_STARTUP				10

#  define MAIN_USART               	(&AVR32_USART1)
#  define MAIN_USART_RX_PIN        	AVR32_USART1_RXD_0_0_PIN
#  define MAIN_USART_RX_FUNCTION   	AVR32_USART1_RXD_0_0_FUNCTION
#  define MAIN_USART_TX_PIN        	AVR32_USART1_TXD_0_0_PIN
#  define MAIN_USART_TX_FUNCTION   	AVR32_USART1_TXD_0_0_FUNCTION
#  define MAIN_USART_CLOCK_MASK   	AVR32_USART1_CLK_PBA
#  define MAIN_PDCA_CLOCK_HSB      	AVR32_PDCA_CLK_HSB
#  define MAIN_PDCA_CLOCK_PB		AVR32_PDCA_CLK_PBA
#  define MAIN_USART_IRQ         	AVR32_USART1_IRQ

#  define AHRS_USART               	(&AVR32_USART2)
#  define AHRS_USART_RX_PIN        	AVR32_USART2_RXD_0_0_PIN
#  define AHRS_USART_RX_FUNCTION   	AVR32_USART2_RXD_0_0_FUNCTION
#  define AHRS_USART_TX_PIN        	AVR32_USART2_TXD_0_0_PIN
#  define AHRS_USART_TX_FUNCTION   	AVR32_USART2_TXD_0_0_FUNCTION
#  define AHRS_USART_CLOCK_MASK    	AVR32_USART2_CLK_PBA
#  define AHRS_PDCA_CLOCK_HSB       AVR32_PDCA_CLK_HSB
#  define AHRS_PDCA_CLOCK_PB      	AVR32_PDCA_CLK_PBA
#  define AHRS_USART_IRQ         	AVR32_USART2_IRQ

#  define LEFT_MOTOR				0 //Vstup 8
#  define RIGTH_MOTOR				1 //Vstup 7
#  define REAR_MOTOR				2 //Vstup 6
#  define TILT_SERVO				3 //Vstup 5
#  define CAMERA_HORIZONTAL			4 //Vstup 2
#  define CAMERA_VERTICAl			5 //Vstup 1
#  define NIC_PWM					6 //Vstup 4

#  define TC                    	(&AVR32_TC)
#  define TC_0_CHANNEL_ID         	0
#  define TC_0_CHANNEL_PIN        	AVR32_TC_A0_0_0_PIN
#  define TC_0_CHANNEL_FUNCTION   	AVR32_TC_A0_0_0_FUNCTION
#  define TC_0_IRQ         			AVR32_TC_IRQ0
/*
#  define ADC_VOLTAGE_CHANNEL     5
#  define ADC_VOLTAGE_PIN         AVR32_ADC_AD_5_PIN
#  define ADC_VOLTAGE_FUNCTION    AVR32_ADC_AD_5_FUNCTION
*/
#include <avr32/io.h>
#include "compiler.h"
#include "pm.h"
#include "power_clocks_lib.h"
#include "gpio.h"
#include "usart.h"
#include "intc.h"
#include "pwm.h"
#include "PID.h"
#include "math.h"
#include "AHRS.h"
#include "tc.h"
#include "INIT.h"
#include "buzzer.h"
//#include "adc.h" //Prozatm nepouvno
#include "FIFO.h"
#include "motors.h"
#include "rtc.h"
#include "error.h"
#include "eic.h"

//DEKLARACE
//Deklarace funkc peruen
static void usart_int_handler(void);
static void main_usart_int_handler(void);
static void rtc_irq(void);
static void eic_int_button_handler(void);
//static void tc_int_handler(void);

//Deklarace funkc
int MAIN_parse(char *data, char rx_char);
int AHRS_parse(char *data, char rx_char);
int convert_to_num(char *data);
void pwm_set (char channel_id,int value);
void pwm_set_servo (char channel_id,int value);
void update_motors(float lift, float pitch, float roll);
void main_usart_number(int number);
void pwm_setup (void);
float gyro_time (float);
void send_data_pc();
void e_stop();
void all_stop();
void comm_watchdog_reset();
void test_watchdog();

//Deklarace promnnch
char MAIN_reading_started = 0;
char MAIN_counter = 0;
char MAIN_G[8] = {0,0,0,0,0,0,0,0};	// plyn
char MAIN_R[8] = {0,0,0,0,0,0,0,0};	// rotace
char MAIN_X[8] = {0,0,0,0,0,0,0,0}; // roll
char MAIN_Y[8] = {0,0,0,0,0,0,0,0}; // pitch
char MAIN_m[8] = {0,0,0,0,0,0,0,0}; // Reim
int gas = 0; // pevedeno na slo
int main_r=0;
int mode=0; // Reim (0=Hover, 1=Manual, 2=Stable, 3=Acrobatic)
int last_mode=0;
float x_axis=0, y_axis=0;

char MAIN_v[8] = {0,0,0,0,0,0,0,0}; // Vertikln pohyb
int camera_v=0;

char MAIN_P[8] = {0,0,0,0,0,0,0,0}; // P-Sloka roll regulace
char MAIN_I[8] = {0,0,0,0,0,0,0,0};	// I-Sloka roll regulace
char MAIN_D[8] = {0,0,0,0,0,0,0,0};	// D-Sloka roll regulace
char MAIN_F[8] = {0,0,0,0,0,0,0,0};	// Fuse gain roll regulace
int main_read_P,main_read_I,main_read_D = 0;//Promnn pro peveden na slo
int main_read_F=0;

char MAIN_L[8] = {0,0,0,0,0,0,0,0}; // P-Sloka pitch regulace
char MAIN_M[8] = {0,0,0,0,0,0,0,0};	// I-Sloka pitch regulace
char MAIN_N[8] = {0,0,0,0,0,0,0,0};	// D-Sloka pitch regulace
char MAIN_O[8] = {0,0,0,0,0,0,0,0};	// Fuse gain pitch regulace
int main_read_L,main_read_M,main_read_N = 0;//Promnn pro peveden na slo
int main_read_O=0;

volatile int watchdog = -1;
volatile int unerror = 0;
volatile int debug = 0;

char AHRS_reading_started = 0;
char AHRS_counter = 0;
char AHRS_pitch[8] = {0,0,0,0,0,0,0,0};
char AHRS_roll[8] = {0,0,0,0,0,0,0,0};
char AHRS_yaw[8] = {0,0,0,0,0,0,0,0};
char AHRS_gz[8] = {0,0,0,0,0,0,0,0};

float pitch=0, roll=0, yaw=0, gz = 0;

int pwm_max[] 		= {1900,1900,1900,1900,2250,2250,1900};
int pwm_min[] 		= {1100,1100,1100,800,750,680,750,1100};
int pwm_startup[] 	= {1100,1100,1100,1500,1500,680,1500,1100};
//float time[3] = {0.01,0.01,0.01};

pwm_opt_t pwm_opt;
pid_t tilt_pid;
pid_t roll_pid;
pid_t pitch_pid;
position_t position;
avr32_pwm_channel_t pwm_channel = { .ccnt = 0 };
motors_t motors;
fifo_t main_usart_tx;
error_t error_handler;
eic_options_t eic_options;

volatile avr32_tc_t *tc = TC;
//KONEC DEKLARACE

int main ()
{
//INICIALIZACE
	init_all();

	//Nastaven zdroje hodin
	pm_enable_osc0_crystal(&AVR32_PM, FOSC0);  // Osc
	pm_enable_clk0(&AVR32_PM, OSC0_STARTUP);
	pm_pll_setup(&AVR32_PM, 0, // pll.
	10, 	// mul.
	1, 	// div.
	0, 	// osc.
	16);	// lockcount.
	pm_pll_set_option(&AVR32_PM, 0, // pll.
	1, 	// pll_freq.
	1, 	// pll_div2.
	0);	// pll_wbwdisable.
	pm_pll_enable(&AVR32_PM, 0);
	pm_wait_for_pll0_locked(&AVR32_PM);
	pm_cksel(&AVR32_PM,
	0, 	// pbadiv.
	0, 	// pbasel.
	0, 	// pbbdiv.
	0, 	// pbbsel.
	1, 	// hsbdiv.
	0);	// hsbsel.
	pm_switch_to_clock(&AVR32_PM, AVR32_PM_MCSEL_PLL0);
	pwm_setup();

	//PID
	PID_setup(&tilt_pid,2,0.1,0.2,200);
	PID_setup(&pitch_pid,1.15,0.004,0.8,20); // 2.8,
	PID_setup(&roll_pid,1.15,0.004,0.8,20); // 1.5,

	//ADC prozatm nepouvno
/*	 static const gpio_map_t ADC_GPIO_MAP =
	   {
	     {ADC_VOLTAGE_PIN, ADC_VOLTAGE_FUNCTION}
	   };
	 volatile avr32_adc_t *adc = &AVR32_ADC; // ADC IP registers address
	 gpio_enable_module(ADC_GPIO_MAP, sizeof(ADC_GPIO_MAP) / sizeof(ADC_GPIO_MAP[0]));

	 //ZDE HLEDAT
	 AVR32_ADC.mr |= 0x1 << AVR32_ADC_MR_PRESCAL_OFFSET;
	 adc_configure(adc);
	 adc_enable(adc,ADC_VOLTAGE_CHANNEL);

*/
	//USART inicializace
	static const gpio_map_t USART1_GPIO_MAP =
	{
		{MAIN_USART_RX_PIN, MAIN_USART_RX_FUNCTION},
	    {MAIN_USART_TX_PIN, MAIN_USART_TX_FUNCTION}
	};
	static const gpio_map_t USART2_GPIO_MAP =
	{
		{AHRS_USART_RX_PIN, AHRS_USART_RX_FUNCTION},
		{AHRS_USART_TX_PIN, AHRS_USART_TX_FUNCTION}
	};
	static const usart_options_t USART1_OPTIONS =
	{
	    .baudrate     = 115200,
	    .charlength   = 8,
	    .paritytype   = USART_NO_PARITY,
	    .stopbits     = USART_1_STOPBIT,
	    .channelmode  = USART_NORMAL_CHMODE
	};
	static const usart_options_t USART2_OPTIONS =
	{
	    .baudrate     = 57600,
	    .charlength   = 8,
	    .paritytype   = USART_NO_PARITY,
	    .stopbits     = USART_1_STOPBIT,
	    .channelmode  = USART_NORMAL_CHMODE
	};
	gpio_enable_module(USART1_GPIO_MAP,
	sizeof(USART1_GPIO_MAP) / sizeof(USART1_GPIO_MAP[0]));
	gpio_enable_module(USART2_GPIO_MAP,
	sizeof(USART2_GPIO_MAP) / sizeof(USART2_GPIO_MAP[0]));

	usart_reset(AHRS_USART);
	usart_init_rs232(AHRS_USART, &USART2_OPTIONS, PBACLK_FREQ_HZ);

	usart_reset(MAIN_USART);
	usart_init_rs232(MAIN_USART, &USART1_OPTIONS, PBACLK_FREQ_HZ);

	// TC
	tc_waveform_opt_t waveform_opt =
	{
		.channel  = TC_0_CHANNEL_ID,        // Channel selection.
		.bswtrg   = TC_EVT_EFFECT_NOOP,           // Software trigger effect on TIOB.
	    .beevt    = TC_EVT_EFFECT_NOOP,           // External event effect on TIOB.
	    .bcpc     = TC_EVT_EFFECT_NOOP,           // RC compare effect on TIOB.
	    .bcpb     = TC_EVT_EFFECT_NOOP,           // RB compare effect on TIOB.

	    .aswtrg   = TC_EVT_EFFECT_NOOP,           // Software trigger effect on TIOA.
	    .aeevt    = TC_EVT_EFFECT_NOOP,           // External event effect on TIOA.
	    .acpc     = TC_EVT_EFFECT_TOGGLE,         // RC compare effect on TIOA: toggle.
	    .acpa     = TC_EVT_EFFECT_TOGGLE,         // RA compare effect on TIOA: toggle (other possibilities are none, set and clear).

	    .wavsel   = TC_WAVEFORM_SEL_UP_MODE_RC_TRIGGER,
	    .enetrg   = FALSE,                        // External event trigger enable.
	    .eevt     = TC_EXT_EVENT_SEL_TIOB_INPUT,  // External event selection.
	    .eevtedg  = TC_SEL_NO_EDGE,               // External event edge selection.
	    .cpcdis   = FALSE,                        // Counter disable when RC compare.
	    .cpcstop  = FALSE,                        // Counter clock stopped with RC compare.

	    .burst    = TC_BURST_NOT_GATED,           // Burst signal selection.
	    .clki     = TC_CLOCK_RISING_EDGE,         // Clock inversion.
	    .tcclks   = TC_CLOCK_SOURCE_TC4
	};
	gpio_enable_module_pin(TC_0_CHANNEL_PIN, TC_0_CHANNEL_FUNCTION);
	tc_init_waveform(tc, &waveform_opt);  // Initialize the timer/counter waveform.
	tc_write_ra(tc, TC_0_CHANNEL_ID, 65535);     // Set RA value.
	tc_write_rc(tc, TC_0_CHANNEL_ID, 65535);     // Set RC value.
	tc_start(tc, TC_0_CHANNEL_ID);// Start the timer/counter.

	//Buzzer - nastaven genertoru sirnky
	buzzer_initialize();

	//INTC - Sprva peruen
	Disable_global_interrupt();
	INTC_init_interrupts();
	INTC_register_interrupt(&usart_int_handler, AHRS_USART_IRQ, AVR32_INTC_INT3);
	INTC_register_interrupt(&main_usart_int_handler, MAIN_USART_IRQ, AVR32_INTC_INT2);

	AHRS_USART->ier = AVR32_USART_IER_RXRDY_MASK;
	MAIN_USART->ier = AVR32_USART_IER_RXRDY_MASK;
	MAIN_USART->ier = AVR32_USART_IER_TXEMPTY_MASK;

	//RTC - zdroj pomalho 1Hzspounn pro pravideln funkce
	INTC_register_interrupt(&rtc_irq, AVR32_RTC_IRQ, AVR32_INTC_INT0);
	if (!rtc_init(&AVR32_RTC, RTC_OSC_32KHZ, RTC_PSEL_32KHZ_1HZ))
	{
		usart_write_line(&AVR32_USART0, "Error initializing the RTC\r\n");
		while(1);
	}
	// Set top value to 0 to generate an interrupt every seconds */
	rtc_set_top_value(&AVR32_RTC, 0);
	rtc_enable_interrupt(&AVR32_RTC);
	rtc_enable(&AVR32_RTC);

	//EIC inicializace externho peruen

	eic_options.eic_mode   = EIC_MODE_EDGE_TRIGGERED;//Reakce na hranu
	eic_options.eic_edge  = EIC_EDGE_FALLING_EDGE;//Sestupn hrana (spn proti zemi)
	eic_options.eic_filter  = EIC_FILTER_ENABLED;//Filtrovn zkmit
	eic_options.eic_async  = EIC_ASYNCH_MODE;//Asynchron reim
	eic_options.eic_line = EXT_INT6; // Enable the chosen external interrupt line.
	gpio_enable_module_pin(AVR32_EIC_EXTINT_6_PIN,AVR32_EIC_EXTINT_6_FUNCTION);
	eic_init(&AVR32_EIC, &eic_options,1);
	eic_enable_line(&AVR32_EIC, EXT_INT6);

	eic_enable_interrupt_line(&AVR32_EIC, eic_options.eic_line);

	INTC_register_interrupt(&eic_int_button_handler, AVR32_EIC_IRQ_6, AVR32_INTC_INT0);

	// vodn testovac etzec pes hlavn usart do PC
	usart_write_line(MAIN_USART, "AT32UC3A1512\n");

	//Nastaven kontrolnho LED indiktoru
	gpio_set_gpio_pin(AVR32_PIN_PA03);

	//Inicializace FIFO pro hlavn usart
	main_usart_tx.start = 0;
	main_usart_tx.end = 0;

	//Povilen peruen - pedn zen
	Enable_global_interrupt();

//KONEC INICIALIZACE

//HLAVN SYMKA
	while(1)
	{
		//Chybov hlen
		int temp;
		temp = error_transmit(&error_handler);
		if(temp != 0){
			fifo_string(&main_usart_tx, "ER:");
			fifo_number(&main_usart_tx, temp);
			fifo_in(&main_usart_tx, ',');
		}
		if(mode!=last_mode){//zmna reimu
			last_mode=mode;
			fifo_string(&main_usart_tx, "MD:");
			fifo_number(&main_usart_tx,mode);
			fifo_in(&main_usart_tx, ',');
		}
		if (AHRS_counter == 6)
		{
			AHRS_counter=0;
			if(mode==0){
			pwm_set_servo(TILT_SERVO,-PID(&tilt_pid,main_r,gz));
			update_motors(gas,PID(&pitch_pid,y_axis,(pitch))/*0*/,PID(&roll_pid,x_axis,roll)/*0*/);
			}
			if(mode==1){
			pwm_set_servo(TILT_SERVO,-PID(&tilt_pid,main_r,gz));
			update_motors(gas,y_axis,x_axis);
			}
			send_data_pc();
		}

	}
//KONEC HLAVN SMYKA
}

//PERUEN

__attribute__((__interrupt__))
//Peruen pjmu dat z PC
static void main_usart_int_handler(void)
{
	if(MAIN_USART->CSR.rxrdy){//pjem
	int symbol;

	if (usart_read_char(MAIN_USART,&symbol) == USART_RX_ERROR) usart_reset_status(MAIN_USART);

	// Probh ten (MAIN_reading_started --> znak zprvy) + Konec (zavoln zpracujc funce)
	switch(MAIN_reading_started)
	{
		case 'G':	MAIN_parse(MAIN_G,symbol);
					if (MAIN_G[7] == 1)
					{
						gas = convert_to_num(MAIN_G);
						MAIN_reading_started = 0;
						MAIN_G[7] = 0;
					}
					break;
		case 'F':	MAIN_parse(MAIN_F,symbol);
					if (MAIN_F[7] == 1)
					{
						main_read_F = convert_to_num(MAIN_F);
						PID_setup(&roll_pid,((float)main_read_P)/1000,((float)main_read_I)/1000,((float)main_read_D)/1000,main_read_F);
						MAIN_reading_started = 0;
						MAIN_F[7] = 0;
					}
					break;
		case 'R':	MAIN_parse(MAIN_R,symbol);
					if (MAIN_R[7] == 1)
					{
						main_r = convert_to_num(MAIN_R);
						MAIN_reading_started = 0;
						MAIN_R[7] = 0;
					}
					break;
		case 'P':	MAIN_parse(MAIN_P,symbol);
					if (MAIN_P[7] == 1)
					{
						main_read_P = convert_to_num(MAIN_P);
						PID_setup(&roll_pid,((float)main_read_P)/1000,((float)main_read_I)/1000,((float)main_read_D)/1000,main_read_F);
						MAIN_reading_started = 0;
						MAIN_P[7] = 0;
					}
					break;
		case 'I':	MAIN_parse(MAIN_I,symbol);
					if (MAIN_I[7] == 1)
					{
						main_read_I = convert_to_num(MAIN_I);
						PID_setup(&roll_pid,((float)main_read_P)/1000,((float)main_read_I)/1000,((float)main_read_D)/1000,main_read_F);
						MAIN_reading_started = 0;
						MAIN_I[7] = 0;
					}
					break;
		case 'D':	MAIN_parse(MAIN_D,symbol);
					if (MAIN_D[7] == 1)
					{
						main_read_D = convert_to_num(MAIN_D);
						PID_setup(&roll_pid,((float)main_read_P)/1000,((float)main_read_I)/1000,((float)main_read_D)/1000,main_read_F);
						MAIN_reading_started = 0;
						MAIN_D[7] = 0;
					}
					break;
		case 'O':	MAIN_parse(MAIN_O,symbol);
					if (MAIN_O[7] == 1)
					{
						main_read_O = convert_to_num(MAIN_O);
						PID_setup(&pitch_pid,((float)main_read_L)/1000,((float)main_read_M)/1000,((float)main_read_N)/1000,main_read_O);
						MAIN_reading_started = 0;
						MAIN_O[7] = 0;
					}
					break;
		case 'L':	MAIN_parse(MAIN_L,symbol);
					if (MAIN_L[7] == 1)
					{
						main_read_L = convert_to_num(MAIN_L);
						PID_setup(&pitch_pid,((float)main_read_L)/1000,((float)main_read_M)/1000,((float)main_read_N)/1000,main_read_O);
						MAIN_reading_started = 0;
						MAIN_L[7] = 0;
					}
					break;
		case 'M':	MAIN_parse(MAIN_M,symbol);
					if (MAIN_M[7] == 1)
					{
						main_read_M = convert_to_num(MAIN_M);
						PID_setup(&pitch_pid,((float)main_read_L)/1000,((float)main_read_M)/1000,((float)main_read_N)/1000,main_read_O);
						MAIN_reading_started = 0;
						MAIN_M[7] = 0;
					}
					break;
		case 'N':	MAIN_parse(MAIN_N,symbol);
					if (MAIN_N[7] == 1)
					{
						main_read_N = convert_to_num(MAIN_N);
						PID_setup(&pitch_pid,((float)main_read_L)/1000,((float)main_read_M)/1000,((float)main_read_N)/1000,main_read_O);
						MAIN_reading_started = 0;
						MAIN_N[7] = 0;
					}
		case 'X':	MAIN_parse(MAIN_X,symbol);
					if (MAIN_X[7] == 1)
					{
						x_axis = convert_to_num(MAIN_X)/10;
						MAIN_reading_started = 0;
						MAIN_X[7] = 0;
					}
		case 'Y':	MAIN_parse(MAIN_Y,symbol);
					if (MAIN_Y[7] == 1)
					{
						y_axis = convert_to_num(MAIN_Y)/10;
						MAIN_reading_started = 0;
						MAIN_Y[7] = 0;
					}
					break;
		case 'm':	MAIN_parse(MAIN_m,symbol);
					if (MAIN_m[7] == 1)
					{
						mode = convert_to_num(MAIN_m);
						MAIN_reading_started = 0;
						MAIN_m[7] = 0;
					}
					break;
		case 'v':	MAIN_parse(MAIN_v,symbol);
					if (MAIN_v[7] == 1)
					{
						camera_v = convert_to_num(MAIN_v);
						pwm_set_servo(CAMERA_VERTICAl, camera_v*13);
						MAIN_reading_started = 0;
						MAIN_v[7] = 0;
					}
					break;
	}
	//pijet prvnho znaku
	if (MAIN_reading_started == 0)
	{
		switch(symbol){
		case 'G':	MAIN_G[6] = 0;
					MAIN_reading_started = 'G';
					MAIN_counter = 0;
					break;
		case 'E':	e_stop();
					break;
		case 'R':	MAIN_R[6] = 0;
					MAIN_reading_started = 'R';
					MAIN_counter = 0;
					break;
		case 'F':	MAIN_F[6] = 0;
					MAIN_reading_started = 'F';
					MAIN_counter = 0;
					break;
		case 'P':	MAIN_P[6] = 0;
					MAIN_reading_started = 'P';
					MAIN_counter = 0;
					break;
		case 'I':	MAIN_I[6] = 0;
					MAIN_reading_started = 'I';
					MAIN_counter = 0;
					break;
		case 'D':	MAIN_D[6] = 0;
					MAIN_reading_started = 'D';
					MAIN_counter = 0;
					break;
		case 'O':	MAIN_O[6] = 0;
					MAIN_reading_started = 'O';
					MAIN_counter = 0;
					break;
		case 'L':	MAIN_L[6] = 0;
					MAIN_reading_started = 'L';
					MAIN_counter = 0;
					break;
		case 'M':	MAIN_M[6] = 0;
					MAIN_reading_started = 'M';
					MAIN_counter = 0;
					break;
		case 'N':	MAIN_N[6] = 0;
					MAIN_reading_started = 'N';
					MAIN_counter = 0;
					break;
		case 'X':	MAIN_X[6] = 0;
					MAIN_reading_started = 'X';
					MAIN_counter = 0;
					break;
		case 'Y':	MAIN_Y[6] = 0;
					MAIN_reading_started = 'Y';
					MAIN_counter = 0;
					break;
		case 'm':	MAIN_m[6] = 0;
					MAIN_reading_started = 'm';
					MAIN_counter = 0;
					break;
		case 'v':	MAIN_v[6] = 0;
					MAIN_reading_started = 'v';
					MAIN_counter = 0;
					break;
		case 0x06:  comm_watchdog_reset();// Znak pro nulovn watchdogu komunikace ovldacho softwaru
					debug=0;
					break;
		case 0x02:	comm_watchdog_reset();// Znak pro nulovn watchdogu komunikace nastavovacho softwaru
					debug=1;
					break;
		case 0x03:	watchdog=-1;
					all_stop();
					break;
		}
	}
	}
	else if(MAIN_USART->csr & AVR32_USART_TXEMPTY_MASK){
		unsigned char temp4;
		if((temp4 = fifo_out(&main_usart_tx))!=0){
		usart_write_char(MAIN_USART,temp4);

		}else{
			main_usart_tx.tip=0;
			MAIN_USART->idr = AVR32_USART_TXEMPTY_MASK;
		}
	}
}

__attribute__((__interrupt__))
//Peruen pjmu dat z AHRS
static void usart_int_handler(void)
{
	int symbol;
	if (usart_read_char(AHRS_USART,&symbol) == USART_RX_ERROR) usart_reset_status(AHRS_USART);
	if (AHRS_reading_started == 1)
	{
		switch(AHRS_counter){
		case 0: if (symbol == ',') AHRS_counter++;
				else AHRS_reading_started=0;
				break;
		case 1:	AHRS_parse(AHRS_roll,symbol);
				break;
		case 2:	AHRS_parse(AHRS_pitch,symbol);
				break;
		case 3:	AHRS_parse(AHRS_yaw,symbol);
				break;
		case 4:	AHRS_parse(AHRS_gz,symbol);
				break;
		case 5: 	if (symbol == '#'){
			tc_software_trigger(tc,TC_0_CHANNEL_ID);
			pitch = ((((float)convert_to_num(AHRS_pitch))/100));// + (2*pitch))/3;
			roll = ((((float)convert_to_num(AHRS_roll))/100));// + (2*roll))/3;
			yaw = ((float)convert_to_num(AHRS_yaw))/100;
			gz = convert_to_num(AHRS_gz);
			AHRS_counter++;
			}
			AHRS_reading_started = 0;
				break;
		default: AHRS_reading_started = 0;
		}
	}
	else if (symbol == '$'){
		 AHRS_reading_started = 1;
		 AHRS_counter = 0;
		 AHRS_pitch[6] = 0;
		 AHRS_pitch[7] = 0;
		 AHRS_roll[6] = 0;
		 AHRS_roll[7] = 0;
		 AHRS_yaw[6] = 0;
		 AHRS_yaw[7] = 0;
		 AHRS_gz[6] = 0;
		 AHRS_gz[7] = 0;
	}
}

__attribute__((__interrupt__))
//Peruen RTC f=1Hz
void rtc_irq(void)
{
  test_watchdog();
  rtc_clear_interrupt(&AVR32_RTC); //Smazat pznak peruen
}


__attribute__((__interrupt__))
static void eic_int_button_handler(void)
{
	mode++;
	eic_clear_interrupt_line(&AVR32_EIC, EXT_INT6);
}

//KONEC PERUEN

//FUNKCE

int AHRS_parse(char *data, char rx_char)
{//Tdn dat AHRS
	if (((rx_char >= 48) & (rx_char <= 57)) | (rx_char == '-' )){
		data[(int)data[6]] = rx_char;
		data[6]++;
	}
	else if (rx_char == ','){
		data[7]=1;
		AHRS_counter++;
	}
	else{
		AHRS_reading_started=0;
		return 0;
	}
	return 1;
}

int MAIN_parse(char *data, char rx_char)
{//Tdn dat z PC
	if (((rx_char >= 48) & (rx_char <= 57)) | (rx_char == '-' )){
		data[(int)data[6]] = rx_char;
		data[6]++;
	}
	else if (rx_char == ';'){
		data[7]=1;
	}
	else{
		MAIN_reading_started=0;
		return 0;
	}
	return 1;
}

int convert_to_num(char *data)
{//Pevod znaku na slo
	int output=0;
	int nasobitel=1;

	while(data[6]>0){
		if(data[data[6]-1]=='-'){
			output*=-1;
		}else{
			output += (data[data[6]-1]-'0')*nasobitel;
			nasobitel*=10;
		}
		data[6]--;
	}
	return output;
}

void pwm_set(char channel_id,int value)
{//Nastaven hodnoty PWM vstupu (0 = konec)
	if(value>=0){
	if(value+pwm_min[(int)channel_id]<=pwm_max[(int)channel_id]){
	pwm_channel.cupd = (value+pwm_min[(int)channel_id]);
	}
	else
	{
		pwm_channel.cupd = (pwm_max[(int)channel_id]);
	}
	pwm_sync_update_channel(channel_id,&pwm_channel);
	}
}

void pwm_set_servo(char channel_id,int value)
{//Nastaven hodnoty PWM vstupu (0 = sted)
	if((pwm_startup[(int)channel_id]+value<=pwm_max[(int)channel_id])&(pwm_startup[(int)channel_id]+value>=pwm_min[(int)channel_id])){
		pwm_channel.cupd = (pwm_startup[(int)channel_id]+value);
	}
	if(pwm_startup[(int)channel_id]+value>pwm_max[(int)channel_id]){ //nastavit max
		pwm_channel.cupd = (pwm_max[(int)channel_id]);
	}
	if(pwm_startup[(int)channel_id]+value<pwm_min[(int)channel_id]){ //nastavit min
		pwm_channel.cupd = (pwm_min[(int)channel_id]);
	}
	pwm_async_update_channel(channel_id,&pwm_channel);
}

void pwm_setup (void)
{//Inicializace PWM modulu a vstup
	//PWM vstupy
	unsigned int channel_id = 0;
	gpio_enable_module_pin(AVR32_PWM_0_PIN, AVR32_PWM_0_FUNCTION);
	gpio_enable_module_pin(AVR32_PWM_1_PIN, AVR32_PWM_1_FUNCTION);
	gpio_enable_module_pin(AVR32_PWM_2_PIN, AVR32_PWM_2_FUNCTION);
	gpio_enable_module_pin(AVR32_PWM_3_PIN, AVR32_PWM_3_FUNCTION);
	gpio_enable_module_pin(AVR32_PWM_4_1_PIN, AVR32_PWM_4_1_FUNCTION);
	gpio_enable_module_pin(AVR32_PWM_5_1_PIN, AVR32_PWM_5_1_FUNCTION);
	gpio_enable_module_pin(AVR32_PWM_6_PIN, AVR32_PWM_6_FUNCTION);
	//PWM konfigurace
	pwm_opt.diva = AVR32_PWM_DIVA_CLK_OFF;
	pwm_opt.divb = AVR32_PWM_DIVB_CLK_OFF;
	pwm_opt.prea = AVR32_PWM_PREA_MCK;
	pwm_opt.preb = AVR32_PWM_PREB_MCK;
	pwm_init(&pwm_opt);

	pwm_channel.CMR.calg = PWM_MODE_LEFT_ALIGNED;       	// Channel mode.
	pwm_channel.CMR.cpol = PWM_POLARITY_HIGH;            	// Channel polarity.
	pwm_channel.CMR.cpd = PWM_UPDATE_DUTY;              	// Not used the first time.
	pwm_channel.CMR.cpre = AVR32_PWM_CPRE_MCK_DIV_32;		// Channel prescaler. //s dlikouAVR32_PWM_CPRE_MCK_DIV_2
	pwm_channel.cdty = 600;   	// Channel duty cycle, should be < CPRD. //cdty*976/1000=time ms
	pwm_channel.cprd = 20000;  	// Channel period.
	for(channel_id=0;channel_id < 7;channel_id++)
	{
		pwm_channel.cdty = pwm_startup[channel_id];
		pwm_channel_init(channel_id, &pwm_channel); 	// Set channel configuration to channel 0.
		pwm_start_channels(1 << channel_id);  // Start channel 0
	}
/*
	//Samostatn nastaven pro motory 100HZ
	pwm_channel.CMR.cpre = AVR32_PWM_CPRE_MCK_DIV_8;
	for(channel_id=0;channel_id < 3;channel_id++)
	{
		pwm_channel.cdty = pwm_startup[channel_id];
		pwm_channel_init(channel_id, &pwm_channel); 	// Set channel configuration to channel 0.
		pwm_start_channels(1 << channel_id);  // Start channel 0
	}

	//Ostatn kanly
	pwm_channel.CMR.cpre = AVR32_PWM_CPRE_MCK_DIV_32;
	for(channel_id=3;channel_id < 7;channel_id++)
	{
		pwm_channel.cdty = pwm_startup[channel_id];
		pwm_channel_init(channel_id, &pwm_channel); 	// Set channel configuration to channel 0.
		pwm_start_channels(1 << channel_id);  // Start channel 0
	}
*/
}

void update_motors(float lift, float pitch, float roll)
{ //Nastaven hodnot motorm

	if (lift < 2) motors.status=0;
	else if ((lift <= 125) & (lift >= 2)) motors.status=1;
	else motors.status = 2;

	motors.m1=lift+(pitch/3)+(roll/1.732);
	motors.m2=lift+(pitch/3)-(roll/1.732)-55;
	motors.m3=lift-((2*pitch)/3);	// 2*

	if(motors.status==0){
		motors.m1 = 0;
		motors.m2 = 0;
		motors.m3 = 0;
	}
	else if(motors.status==1){
		motors.m1 = 125;
		motors.m2 = 125;
		motors.m3 = 125;
	}
	else
	{
		if(motors.m1<125) motors.m1 = 125;
		if(motors.m2<125) motors.m2 = 125;
		if(motors.m3<125) motors.m3 = 125;
	}

	pwm_set(LEFT_MOTOR,motors.m1);
	pwm_set(RIGTH_MOTOR,motors.m2);
	pwm_set(REAR_MOTOR,motors.m3);
}

void send_data_pc()
{//Pravideln odesln dat do PC
	//Pitch hel nklonu (levo-prav)
	fifo_string(&main_usart_tx, "PH:");
	fifo_number(&main_usart_tx,pitch*100);
	fifo_in(&main_usart_tx, ',');
	//Roll hel nklonu (pedo-zadn)
	fifo_string(&main_usart_tx, "RL:");
	fifo_number(&main_usart_tx,roll*100);
	fifo_in(&main_usart_tx, ',');
	//Rychlost rotace (v st/sek)
	fifo_string(&main_usart_tx, "GZ:");
	fifo_number(&main_usart_tx,gz);
	fifo_in(&main_usart_tx, ',');
	//Kompasov hel (nevit)
	fifo_string(&main_usart_tx, "ANG:");
	fifo_number(&main_usart_tx, yaw);
	fifo_in(&main_usart_tx, ',');
	if(debug!=0){//pouze pi nastavovn
		//P sloka roll (levo-prav) regulace
		fifo_string(&main_usart_tx, "RP:");
		fifo_number(&main_usart_tx, roll_pid.p);
		fifo_in(&main_usart_tx, ',');
		//I sloka roll (levo-prav) regulace
		fifo_string(&main_usart_tx, "RI:");
		fifo_number(&main_usart_tx, roll_pid.i);
		fifo_in(&main_usart_tx, ',');
		//D sloka roll (levo-prav) regulace
		fifo_string(&main_usart_tx, "RD:");
		fifo_number(&main_usart_tx, roll_pid.d);
		fifo_in(&main_usart_tx, ',');
		//P sloka pitch (pedo-zadn) regulace
		fifo_string(&main_usart_tx, "PP:");
		fifo_number(&main_usart_tx, pitch_pid.p);
		fifo_in(&main_usart_tx, ',');
		//I sloka pitch (pedo-zadn) regulace
		fifo_string(&main_usart_tx, "PI:");
		fifo_number(&main_usart_tx, pitch_pid.i);
		fifo_in(&main_usart_tx, ',');
		//D sloka pitch (pedo-zadn) regulace
		fifo_string(&main_usart_tx, "PD:");
		fifo_number(&main_usart_tx, pitch_pid.d);
		fifo_in(&main_usart_tx, ',');
	}
	//Otky motoru 1
	fifo_string(&main_usart_tx, "M1:");
	fifo_number(&main_usart_tx, motors.m1);
	fifo_in(&main_usart_tx, ',');
	//Otky motoru 2
	fifo_string(&main_usart_tx, "M2:");
	fifo_number(&main_usart_tx, motors.m2);
	fifo_in(&main_usart_tx, ',');
	//Otky motoru 3
	fifo_string(&main_usart_tx, "M3:");
	fifo_number(&main_usart_tx, motors.m3);
	fifo_in(&main_usart_tx, ',');
	//Konec dku
	fifo_in(&main_usart_tx,13);
	fifo_in(&main_usart_tx,10);
}

void e_stop()
{//Nouzov vypnut z PC (zatm pi komunikanm watchdog timeoutu)
	unerror = 0;
	update_motors(0,0,0);
	buzzer_on(2000);
	while(!unerror){
		if(usart_getchar(MAIN_USART)==18)unerror = 1;
	}
}

void all_stop()
{//Vypnut z PC
	gas = 0;
	update_motors(0,0,0);
}

void comm_watchdog_reset()
{//Reset komunikanho watchdogu (pijet 0x06, pravideln 2x/s pi komunikaci)
	watchdog = 3;
}

void test_watchdog()
{//Odeten watchdogu (volno z RTC peruen)
	if(watchdog != -1)watchdog--;
	if(watchdog == 0) e_stop();
}
